// Author: Hezhk3

// see https://gl-transitions.com/editor/angular

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define PI 3.141592653589
#define STARTING_ANGLE 270.0

void main()
{
    highp vec2 uv = textureCoordinate;
    highp float process = fract(iTime);
    
    highp float offset = STARTING_ANGLE * PI / 180.0;
    highp float angle = atan(uv.y - 0.5, uv.x - 0.5) + offset;
    highp float normalizedAngle = (angle + PI) / (2.0 * PI);
    
    normalizedAngle = normalizedAngle - floor(normalizedAngle);
    
    gl_FragColor = mix(texture2D(inputImageTexture, uv), texture2D(inputImageTexture2, uv), step(normalizedAngle, process));
}
