// Author: Hezhk3

// see https://gl-transitions.com/editor/circle

// modified from ellipse to circle
// eliminated if-else statement

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define CENTER vec2(0.5, 0.5)
#define BACK_COLOR vec3(0., 0., 0.)

void main()
{
    highp vec2 uv = textureCoordinate;
    highp float progress = fract(iTime);
    highp float aspect = iResolution.x / iResolution.y;
    highp float r = sqrt(2.) * max(1., aspect);
    highp float R = sqrt(1. + aspect * aspect);
    progress = progress * R / r;
    
    highp vec2 vector = uv - CENTER;
    vector = vec2(vector.x * min(aspect, 1.), vector.y / max(aspect, 1.));
    
    highp float distance = length(vector);
    highp float radius = sqrt(8.0) * abs(progress - 0.5);
    
    gl_FragColor = mix(mix(texture2D(inputImageTexture, uv),
                           texture2D(inputImageTexture2, uv),
                           step(0.5, progress)),
                       vec4(BACK_COLOR, 1.0),
                       step(radius, distance));
}
