// Author: Hezhk3

// see https://gl-transitions.com/editor/GlitchMemories

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

highp vec4 getFromColor(highp vec2 coord) {
    return texture2D(inputImageTexture, coord);
}

highp vec4 getToColor(highp vec2 coord) {
    return texture2D(inputImageTexture2, coord);
}

void main()
{
    highp vec2 p = textureCoordinate;
    highp float progress = fract(iTime);
    
    highp vec2 block = floor(p.xy / vec2(16));
    highp vec2 uv_noise = block / vec2(64);
    uv_noise += floor(vec2(progress) * vec2(1200.0, 3500.0)) / vec2(64);
    highp vec2 dist = progress > 0.0 ? (fract(uv_noise) - 0.5) * 0.3 *(1.0 -progress) : vec2(0.0);
    highp vec2 red = p + dist * 0.2;
    highp vec2 green = p + dist * .3;
    highp vec2 blue = p + dist * .5;
    
    gl_FragColor = vec4(mix(getFromColor(red),
                            getToColor(red),
                            progress).r,
                        mix(getFromColor(green),
                            getToColor(green),
                            progress).g,
                        mix(getFromColor(blue),
                            getToColor(blue),
                            progress).b,
                        1.0);
}
