// Author: Hezhk3

// see https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
//#define getFromColor(coord) texture2D(inputImageTexture, coord)
//#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

#define R_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) texture2D(inputImageTexture, R_VEC2(coord))
#define getToColor(coord) texture2D(inputImageTexture2, R_VEC2(coord))

highp float inHeart (highp vec2 p, highp vec2 center, highp float size) {
     if (size==0.0) return 0.0;

     highp vec2 o = (p-center)/(1.6*size);
     highp float a = o.x*o.x+o.y*o.y-0.3;
     return step(a*a*a, o.x*o.x*o.y*o.y*o.y);
 }

 void main()
{
    float maxR = max(iResolution.x, iResolution.y);

    highp vec2 uv = textureCoordinate;
    uv *= iResolution / maxR;
//    uv.y = 1.0 - uv.y;

    highp vec2 op = vec2(0.5, 0.4);
    op *= iResolution / maxR;

    float t = progress;
    t = smoothstep(0.0, 1.0, t);
    t = smoothstep(0.0, 1.0, t);

    gl_FragColor = mix(texture2D(inputImageTexture, textureCoordinate),
                       texture2D(inputImageTexture2, textureCoordinate),
                       inHeart(uv, op, t));
}

