precision highp float;
#define progress iTime
#define iChannel0 inputImageTexture
#define iChannel1 inputImageTexture2
#define texture(a,b) texture2D(a,fract(b))
#define fragColor gl_FragColor
 varying vec2 textureCoordinate;

 uniform sampler2D inputImageTexture;
 uniform sampler2D inputImageTexture2;

 uniform highp vec2 iResolution;

 uniform float progress;

 highp float rand(highp vec2 co) {
     return fract(sin(dot(co.xy ,vec2(12.9898,78.233)*3.141)) * 43758.5453);
 }


 void main()
{
    highp vec2 uv = textureCoordinate;

    highp vec4 color1 = texture(iChannel0, uv);
    highp vec4 color2 = texture(iChannel1, uv);

    highp vec2 maxR = vec2(max(iResolution.x, iResolution.y));
    uv = (iResolution.xy * uv) / maxR;

    int c = 25;

    float xx = 1.0;
    float maxd = 0.4;
    float bb = 0.0;

    float t = progress;
    t = smoothstep(0., 1., t);

    highp vec2 op = vec2(0.5);

    for (int i = 0; i < c; i++) {
        op = vec2(rand(op * 39.9), rand(op * 999.9));
        op = (iResolution.xy * op) / maxR;
        float d = length(uv - op);
        float tt = t * maxd - float(i + 1) / 2. / float(c) * rand(op);
        xx *= step(tt, d);
        bb = max(bb, step(abs(tt - d), 0.003));
    }

    fragColor = mix(color2, color1, xx);

    fragColor = mix(fragColor, vec4(1.), step(2., bb + xx));
}