// Author: Hezhk3

// see https://gl-transitions.com/editor/morph

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

// Author: paniq
// License: MIT
const highp float strength = 0.1; // = 0.1

highp vec4 transition(highp vec2 p) {
    highp vec4 ca = getFromColor(p);
    highp vec4 cb = getToColor(p);
    
    highp vec2 oa = (((ca.rg+ca.b)*0.5)*2.0-1.0);
    highp vec2 ob = (((cb.rg+cb.b)*0.5)*2.0-1.0);
    highp vec2 oc = mix(oa,ob,0.5)*strength;
    
    highp float w0 = progress;
    highp float w1 = 1.0-w0;
    return mix(getFromColor(p+oc*w0), getToColor(p-oc*w1), progress);
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
