// Author: Hezhk3

// see https://gl-transitions.com/editor/Mosaic

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

// License: MIT
// Author: Xaychru
// ported by gre from https://gist.github.com/Xaychru/130bb7b7affedbda9df5

#define PI 3.14159265358979323
#define POW2(X) X*X
#define POW3(X) X*X*X
const highp int endx = 2; // = 2
const highp int endy = -1; // = -1

highp float Rand(highp vec2 v) {
    return fract(sin(dot(v.xy ,vec2(12.9898,78.233))) * 43758.5453);
}
highp vec2 Rotate(highp vec2 v, highp float a) {
    highp mat2 rm = mat2(cos(a), -sin(a),
                         sin(a), cos(a));
    return rm*v;
}
highp float CosInterpolation(highp float x) {
    return -cos(x*PI)/2.+.5;
}
highp vec4 transition(highp vec2 uv) {
    highp vec2 p = uv.xy / vec2(1.0).xy - .5;
    highp vec2 rp = p;
    highp float rpr = (progress*2.-1.);
    highp float z = -(rpr*rpr*2.) + 3.;
    highp float az = abs(z);
    rp *= az;
    rp += mix(vec2(.5, .5), vec2(float(endx) + .5, float(endy) + .5), POW2(CosInterpolation(progress)));
    highp vec2 mrp = mod(rp, 1.);
    highp vec2 crp = rp;
    bool onEnd = int(floor(crp.x))==endx&&int(floor(crp.y))==endy;
    if(!onEnd) {
        highp float ang = float(int(Rand(floor(crp))*4.))*.5*PI;
        mrp = vec2(.5) + Rotate(mrp-vec2(.5), ang);
    }
    if(onEnd || Rand(floor(crp))>.5) {
        return getToColor(mrp);
    } else {
        return getFromColor(mrp);
    }
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
