// Author: Hezhk3

// see https://gl-transitions.com/editor/pinwheel

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

const highp float speed = 2.0; // = 2.0;

highp vec4 transition(highp vec2 uv) {
    
    highp vec2 p = uv.xy / vec2(1.0).xy;
    
    highp float circPos = atan(p.y - 0.5, p.x - 0.5) + progress * speed;
    highp float modPos = mod(circPos, 3.1415 / 4.);
    highp float signed = sign(progress - modPos);
    
    return mix(getToColor(p), getFromColor(p), step(signed, 0.5));
    
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
