// Author: Hezhk3

// see https://gl-transitions.com/editor/polar_function

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

#define PI 3.14159265359

const highp int segments = 5; // = 5;

highp vec4 transition (highp vec2 uv) {

    uv.y = 1.0 - uv.y;
//    highp float angle = atan(uv.y - 0.5, uv.x - 0.5) - 0.5 * PI;
    highp float angle = atan(0.5 - uv.y, uv.x - 0.5) - 0.5 * PI; // fix坐标系
    highp float normalized = (angle + 1.5 * PI) * (2.0 * PI);
    
    highp float radius = (cos(float(segments) * angle) + 4.0) / 4.0;
    highp float difference = length(uv - vec2(0.5, 0.5));
    
    if (difference > radius * progress)
        return getFromColor(uv);
    else
        return getToColor(uv);
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
