// Author: Hezhk3

// see https://gl-transitions.com/editor/PolkaDotCurtain
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

// author: bobylito
// license: MIT
const highp float SQRT_2 = 1.414213562373;
const highp float dots = 20.0;// = 20.0;
const highp vec2 center = vec2(0, 0);// = vec2(0, 0);

highp vec4 transition(highp vec2 uv) {
    vec4 fromC = getFromColor(uv);
    vec4 toC = getToColor(uv);
    highp float maxR = max(iResolution.x, iResolution.y);
    uv *= iResolution / maxR;
    bool nextImage = distance(fract(uv * dots), vec2(0.5, 0.5)) < ( progress / distance(uv, center));
    return nextImage ? toC : fromC;
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
