// Author: Hezhk3

// see https://gl-transitions.com/editor/randomsquares

// modified from rectangle to square

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

// maximum number of squares
#define N_SQUARES 20.

// transition smoothness
#define SMOOTHNESS .5

highp float rand (highp vec2 co) {
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main()
{
    highp vec2 uv = textureCoordinate;
    highp float progress = fract(iTime);
    highp float aspect = iResolution.x / iResolution.y;
    
    highp vec2 actualSize = vec2(N_SQUARES * min(aspect, 1.), N_SQUARES / max(aspect, 1.));
    
    highp float r = rand(floor(actualSize * uv));
    highp float m = smoothstep(0.0, -SMOOTHNESS, r - (progress * (1.0 + SMOOTHNESS)));
    gl_FragColor = mix(texture2D(inputImageTexture, uv),
                       texture2D(inputImageTexture2, uv),
                       m);
}
