// Author: Hezhk3

// see https://gl-transitions.com/editor/ripple

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

// Author: gre
// License: MIT
const highp float amplitude = 100.0; // = 100.0
const highp float speed = 50.0; // = 50.0

highp vec4 transition (highp vec2 uv) {
    highp vec2 dir = uv - vec2(.5);
    highp float dist = length(dir);
    highp vec2 offset = dir * (sin(progress * dist * amplitude - progress * speed) + .5) / 30.;
    return mix(
               getFromColor(uv + offset),
               getToColor(uv),
               smoothstep(0.2, 1.0, progress)
               );
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
