// Author: Hezhk3

// see https://gl-transitions.com/editor/BowTieVertical

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

const highp float colorSeparation = 0.04; // = 0.04

highp vec4 transition (highp vec2 uv) {
    highp float y = 0.5 + (uv.y-0.5) / (1.0-progress);
    if (y < 0.0 || y > 1.0) {
        return getToColor(uv);
    }
    else {
        highp vec2 fp = vec2(uv.x, y);
        highp vec2 off = progress * vec2(0.0, colorSeparation);
        highp vec4 c = getFromColor(fp);
        highp vec4 cn = getFromColor(fp - off);
        highp vec4 cp = getFromColor(fp + off);
        return vec4(cn.r, c.g, cp.b, c.a);
    }
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
