precision highp float;
#define progress iTime
#define iChannel0 inputImageTexture
#define iChannel1 inputImageTexture2
#define texture(a,b) texture2D(a,fract(b))
#define fragColor gl_FragColor
 varying vec2 textureCoordinate;

 uniform sampler2D inputImageTexture;
 uniform sampler2D inputImageTexture2;

 uniform highp vec2 iResolution;

 uniform float progress;

 const float segments = 5.0;
 const float indent = 0.1;
 const float softness = 0.02;

 const float pi = 3.141592654;

 void main()
{
    highp vec2 p = textureCoordinate;

    highp vec2 q = p - vec2(0.5, 0.5);
    q *= normalize(iResolution).xy; // maintain aspect ratio

    // Rotation
    float startAngle = 54. / 180. * pi;

    highp mat2 RotationMatrix = mat2(
                               cos( startAngle ), -sin( startAngle ),
                               sin( startAngle ),  cos( startAngle )
                               );
    q = RotationMatrix * q;

    float distance = length(q);
    float t = progress * 2.5;

    highp vec4 col = texture(iChannel0, p);

    float angle = (atan(q.y, q.x) + pi) / (2.0 * pi); // 0-1

    float segment = angle * segments;


    float segmentI = floor(segment);
    float segmentF = fract(segment);

    angle = (segmentI + 0.5) / segments;
    if (segmentF > 0.5) {
        angle -= indent;
    } else
    {
        angle += indent;
    }
    angle *= 2.0 * pi;

    highp vec2 outline;
    outline.y = sin(angle);
    outline.x = cos(angle);

    distance = abs(dot(outline, q));

    float xx = smoothstep(t, t + softness, distance * 6.0);

    highp vec4 starcol = texture( iChannel1, p);
    col = mix(starcol, col, xx);
    fragColor = vec4((col));

}