// Author: Hezhk3

// see https://gl-transitions.com/editor/WaterDrop

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)
#define ratio (iResolution.x / iResolution.y)

// author: Paweł Płóciennik
// license: MIT
const highp float amplitude = 30.0; // = 30
const highp float speed = 30.0; // = 30

highp vec4 transition(highp vec2 p) {
    highp vec2 dir = p - vec2(.5);
    highp float dist = length(dir);
    
    if (dist > progress) {
        return mix(getFromColor( p), getToColor( p), progress);
    } else {
        highp vec2 offset = dir * sin(dist * amplitude - progress * speed);
        return mix(getFromColor( p + offset), getToColor( p), progress);
    }
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
