// Author: Hezhk3

// see https://gl-transitions.com/editor/windowslice

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

#define progress fract(iTime)
#define getFromColor(coord) texture2D(inputImageTexture, coord)
#define getToColor(coord) texture2D(inputImageTexture2, coord)

#define count 10.0
#define smoothness 0.5

highp vec4 transition (highp vec2 p) {
    highp float pr = smoothstep(-smoothness, 0.0, p.x - progress * (1.0 + smoothness));
    highp float s = step(pr, fract(count * p.x));
    return mix(getFromColor(p), getToColor(p), s);
}

void main()
{
    gl_FragColor = transition(textureCoordinate);
}
